//! @file usb_descriptors.h,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief USBʎq
//!
//! ̧ق͋Lqq\ʂđeʋLʂɎʂUSBҰ܂݂܂B
//!
//! @version 1.1 at90usb128-otg-dual_role-toggle-1_0_0 $Id: usb_descriptors.h,v 1.1 2007/02/16 13:13:11 arobert Exp $
//!
//! @todo
//! @bug

#ifndef _USB_USERCONFIG_H_
#define _USB_USERCONFIG_H_

//_____ ݸٰ _______________________________________________________________

#include "config.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "conf_usb.h"

//_____ ϸ ___________________________________________________________________

#define Usb_get_dev_desc_pointer()		(&(usb_dev_desc.bLength))
#define Usb_get_dev_desc_length()		(sizeof (usb_dev_desc))
#define Usb_get_conf_desc_pointer()		(&(usb_conf_desc.cfg_mouse.bLength))
#define Usb_get_conf_desc_length()		(sizeof (usb_conf_desc))

//_____ USB` _______________________________________________________________

  // USBuLqq
#define USB_SPECIFICATION	0x0200
#define DEVICE_CLASS		0		// e`Ԑݒ͂ꎩg̸׽܂B
#define DEVICE_SUB_CLASS	0		// e`Ԑݒ͂ꎩg̕׽܂B
#define DEVICE_PROTOCOL		0		// e`Ԑݒ͂ꎩg̋K܂B
#define EP_CONTROL_LENGTH	8
#define VENDOR_ID			0x03EB	// ATMEL̋ID=$03EB
#define PRODUCT_ID			0x2031	// HIDpPID : LEDݐ؂ւ
#define RELEASE_NUMBER		0x1000
#define MAN_INDEX			0x01
#define PROD_INDEX			0x02
#define SN_INDEX			0x03
#define NB_CONFIGURATION	1

  // `Ԑݒ
#define NB_INTERFACE		1
#define CONF_NB				1
#define CONF_INDEX			0
#define CONF_ATTRIBUTES	(USB_CONFIG_SELFPOWERED)
#define MAX_POWER			50		// 100mA

  // OTGLqq : gpȂ΋@\"1"ɁAȂ"0"ɐݒ肵ĂB
#define OTG_BMATTRIBUTES	(HNP_SUPPORT | SRP_SUPPORT)

  // USB̪Lqq Spider Basic
#define INTERFACE_NB_SPIDER			0
#define ALTERNATE_SPIDER			0
#define NB_ENDPOINT_SPIDER			1
#define INTERFACE_CLASS_SPIDER		HID_CLASS		// HID׽
#define INTERFACE_SUB_CLASS_SPIDER	NO_SUBCLASS		// ׽Ȃ
#define INTERFACE_PROTOCOL_SPIDER	MOUSE_PROTOCOL	// ϳK
#define INTERFACE_INDEX_SPIDER		0

#define SELF_POWERED				1
#define DEVICE_STATUS				SELF_POWERED
#define INTERFACE_STATUS			0x00			// TBD

  // USB߲1Lqq FS
#define ENDPOINT_NB_1				(EP_SPIDER_IN | 0x80)
#define EP_ATTRIBUTES_1				0x03			// (ٸ)=0x02, 荞=0x03
#define EP_IN_LENGTH_1				8
#define EP_SIZE_1					EP_IN_LENGTH_1
#define EP_INTERVAL_1				50 				// νĂmsł̊荞߰ݸފԊu

  // HIDdl
#define HID							0x21
#define REPORT						0x22
#define SET_REPORT					0x02

#define HID_DESCRIPTOR				0x21
#define HID_BDC						0x1001
#define HID_COUNTRY_CODE			0x00
#define HID_CLASS_DESC_NB			0x01
#define HID_DESCRIPTOR_TYPE			0x22

#define LANG_ID						0x00

#define USB_MN_LENGTH				5
#define USB_MANUFACTURER_NAME \
{
	Usb_unicode('A'), \
	Usb_unicode('T'), \
	Usb_unicode('M'), \
	Usb_unicode('E'), \
	Usb_unicode('L') \
}

#define USB_PN_LENGTH				21
#define USB_PRODUCT_NAME \
{
	Usb_unicode('A'), \
	Usb_unicode('V'), \
	Usb_unicode('R'), \
	Usb_unicode('U'), \
	Usb_unicode('S'), \
	Usb_unicode('B'), \
	Usb_unicode(' '), \
	Usb_unicode('O'), \
	Usb_unicode('T'), \
	Usb_unicode('G'), \
	Usb_unicode(' '), \
	Usb_unicode('M'), \
	Usb_unicode('O'), \
	Usb_unicode('U'), \
	Usb_unicode('S'), \
	Usb_unicode('E'), \
	Usb_unicode(' '), \
	Usb_unicode('D'), \
	Usb_unicode('E'), \
	Usb_unicode('M'), \
	Usb_unicode('O') \
}

#define USB_SN_LENGTH				0x0D
  // ʔԂ͍Œ12łׂłB
#define USB_SERIAL_NUMBER \
{
	Usb_unicode('1'), \
	Usb_unicode('.'), \
	Usb_unicode('0'), \
	Usb_unicode('.'), \
	Usb_unicode('0'), \
	Usb_unicode('.'), \
	Usb_unicode('0'), \
	Usb_unicode('.'), \
	Usb_unicode('0'), \
	Usb_unicode('.'), \
	Usb_unicode('0'), \
	Usb_unicode('.'), \
	Usb_unicode('A') \
}

#define LANGUAGE_ID					0x0409

  //! USBv
typedef struct
{
	U8	bmRequestType;			//!< v̓
	U8	bRequest;				//!< wv
	U16	wValue;					//!< (vɏ]ĕω̈)
	U16	wIndex;					//!< (vɏ]ĕω̈)
	U16	wLength;				//!< ް̏ꍇA]޲Đ
} S_UsbRequest;

  //! USBuLqq
typedef struct
{
	U8	bLength;				//!< ̋Lqq޲Ăł̗
	U8	bDescriptorType;		//!< uLqq`
	U16	bscUSB;					//!< 2i10iłUSBdlJ
	U8	bDeviceClass;			//!< USBɂĊ蓖Ăꂽ׽
	U8	bDeviceSubClass;		//!< USBɂĊ蓖Ăꂽ׽
	U8	bDeviceProtocol;		//!< USBɂĊ蓖ĂꂽK񕄍
	U8	bMaxPacketSize0;		//!< ߲0ɑ΂ő߹ėe
	U16	idVendor;				//!< IDAATMEL=$03EB
	U16	idProduct;				//!< Ǝ҂ɂĊ˓ĂꂽiID
	U16	bcdDevice;				//!< uJԍ
	U8	iManufacturer;			//!< ƎҕLqq̎wW
	U8	iProduct;				//!< iLqq̎wW
	U8	iSerialNumber;			//!< ʔԕLqq̎wW
	U8	bNumConfigurations;		//!< \Ȍ`Ԑݒ萔
} S_usb_device_descriptor;

  //! USB`ԐݒLqq
typedef struct
{
	U8	bLength;				//!< ̋Lqq޲Ăł̗
	U8	bDescriptorType;		//!< `ԐݒLqq`
	U16	wTotalLength;			//!< Ԃް̍v
	U8	bNumInterfaces;			//!< ̌`Ԑݒ̂߂̲̪
	U8	bConfigurationValue;	//!< SetConfigurationvɑ΂l
	U8	iConfiguration;			//!< Lqq̎wW
	U8	bmAttibutes;			//!< `Ԑݒ
	U8	MaxPower;				//!< őd
} S_usb_configuration_descriptor;

  //! OTGLqq
typedef struct
{
	U8	bLength;				//!< ̋Lqq޲Ăł̗
	U8	bDescriptorType;		//!< OTGLqq`
	U8	bmAttributes;			//!< HNPSRP̋@\x
} S_usb_otg_descriptor;

  //! USB̪Lqq
typedef struct
{
	U8	bLength;				//!< ̋Lqq޲Ăł̗
	U8	bDescriptorType;		//!< ̪Lqq`
	U8	bInterfaceNumber;		//!< ̪
	U8	bAlternateSetting;		//!< ֐ݒÎ߂̒l
	U8	bNumEndpoints;			//!< ߲0߲Đ
	U8	bInterfaceClass;		//!< USBɂĊ蓖Ăꂽ׽
	U8	bInterfaceSubClass;		//!< USBɂĊ蓖Ăꂽ׽
	U8	bInterfaceProtocol;		//!< USBɂĊ蓖ĂꂽK񕄍
	U8	iInterface;				//!< Lqq̎wW
} S_usb_interface_descriptor;

  //! USB߲ċLqq
typedef struct
{
	U8	bLength;				//!< ̋Lqq޲Ăł̗
	U8	bDescriptorType;		//!< ߲ċLqq`
	U8	bEndpointAddress;		//!< ߲Ă̱ڽ
	U8	bmAttributes;			//!< ߲Ă̑
	U16	wMaxPacketSize;			//!< ̴߲݂̍ő߹ėe
	U8	bInterval;				//!< ߰ݸ ߲ėpmsł̊Ԋu
} S_usb_endpoint_descriptor;

  //! USBuCLqq
typedef struct
{
	U8	bLength;				//!< ̋Lqq޲Ăł̗
	U8	bDescriptorType;		//!< uCLqq`
	U16	bscUSB;					//!< 2i10iłUSBdlJ
	U8	bDeviceClass;			//!< USBɂĊ蓖Ăꂽ׽
	U8	bDeviceSubClass;		//!< USBɂĊ蓖Ăꂽ׽
	U8	bDeviceProtocol;		//!< USBɂĊ蓖ĂꂽK񕄍
	U8	bMaxPacketSize0;		//!< ߲0ɑ΂ő߹ėe
	U8	bNumConfigurations;		//!< \Ȍ`Ԑݒ萔
	U8	bReserved;				//!< ̎gp̂߂̗\A0łȂ΂Ȃ܂B
} S_usb_device_qualifier_descriptor;

  //! USBLqq
typedef struct
{
	U8	bLength;				//!< ̋Lqq޲Ăł̗
	U8	bDescriptorType;		//!< Lqq`
	U16	wlangid;				//!< ID
} S_usb_language_id;

//_____ USBƎҋLqq _____________________________________________________

// usb_st_manufacturer\
typedef struct
{
	U8  bLength;				// ̋Lqq޲Ăł̗
	U8  bDescriptorType;		// Lqq`
	U16 wstring[USB_MN_LENGTH];	// ƺޕ
} S_usb_manufacturer_string_descriptor;

//_____ USBiLqq _________________________________________________________

// usb_st_product\
typedef struct
{
	U8  bLength;				// ̋Lqq޲Ăł̗
	U8  bDescriptorType;		// Lqq`
	U16 wstring[USB_PN_LENGTH];	// ƺޕ
} S_usb_product_string_descriptor;

//_____ USBʔԋLqq _________________________________________________________

// usb_st_serial_number\
typedef struct
{
	U8  bLength;				// ̋Lqq޲Ăł̗
	U8  bDescriptorType;		// Lqq`
	U16 wstring[USB_SN_LENGTH];	// ƺޕ
} S_usb_serial_number;

/*_____ USB HIDLqq _______________________________________________________*/

typedef struct
{
	U8  bLength;				/* ̋Lqq޲Ăł̗ */
	U8  bDescriptorType;		/* HIDLqq` */
	U16 bscHID;					/* 2i10iłUSBdlJ */
	U8  bCountryCode;			/* ʰ޳ړIΏۍ */
	U8  bNumDescriptors;		/* ]HID׽Lqq */
	U8  bRDescriptorType;		/* 񍐋Lqq` */
	U16 wDescriptorLength;		/* 񍐋Lqq̍v */
} S_usb_hid_descriptor;

typedef struct
{
	S_usb_configuration_descriptor	cfg_mouse;
	S_usb_otg_descriptor			otg_dsc;
	S_usb_interface_descriptor		ifc_mouse;
	S_usb_hid_descriptor			hid_mouse;
	S_usb_endpoint_descriptor		ep1_spider;
} S_usb_user_configuration_descriptor;

#endif
