//! @file usb_host_enum.h,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief USBνė(ڑF)ͯ ̧
//!
//! ̧ق͕W(ڑF)菇ɑΉUSB߲0Ǘٰ݂܂݂܂(USBd
//! l̑9͂Q)B
//!
//! @version 1.12 at90usb128-otg-dual_role-toggle-1_0_0 $Id: usb_host_enum.h,v 1.12 2007/02/13 10:14:12 arobert Exp $
//!
//! @todo
//! @bug

#ifndef _USB_HOST_ENUM_H_
#define _USB_HOST_ENUM_H_

//_____ ݸٰ ____________________________________________________________

#include "modules/usb/usb_task.h"

//_____ ϸ ________________________________________________________________

#ifndef SIZEOF_DATA_STAGE
  #error SIZEOF_DATA_STAGE should be defined in conf_usb.h
#endif

#if (SIZEOF_DATA_STAGE<0xFF)				//! data_stage[]eʂɏ]ċLqqψʎwWœK
  #define T_DESC_OFFSET		U8				//! U8͏[荂
#else
  #define T_DESC_OFFSET		U16				//! U16KvƂ!
#endif

#ifndef MAX_EP_PER_INTERFACE
  #define MAX_EP_PER_INTERFACE 4
#endif

#define BIT_SELF_POWERED	6				// ψ(̾)
#define BIT_REMOTE_WAKEUP	5				// ψ(̾)

#define BIT_SRP_SUPPORT		0				// ψ(̾)
#define BIT_HNP_SUPPORT		1				// ψ(̾)

//_____ W` ___________________________________________________________

//! @defgroup host_enum USBνė(ڑF)֐
//! @{

//! USB\ݒ(SETUP)ް
typedef struct
{
	U8  bmRequestType;						//!< v̓
	U8  bRequest;							//!< wv
	U16 wValue;								//!< vɏ]ĕς̈
	U16 wIndex;								//!< vɏ]ĕς̈
	U16 wLength;							//!< ްȂΓ]޲Đ
	U8  uncomplete_read;					//!< 1=1ǂݍ݂̂
} S_usb_setup_data;

typedef struct
{
	U8  interface_nb;
	U8  altset_nb;
	U16 class;
	U16 subclass;
	U16 protocol;
	U8  nb_ep;
	S_usb_endpoint ep[MAX_EP_PER_INTERFACE];
} S_interface;

extern S_usb_setup_data usb_request;
extern U8 data_stage[SIZEOF_DATA_STAGE];
extern U8 device_status;

#define REQUEST_TYPE_POS				0
#define REQUEST_POS						1
#define VALUE_HIGH_POS					2
#define VALUE_LOW_POS					3
#define INDEX_HIGH_POS					4
#define INDEX_LOW_POS					5
#define LENGTH_HIGH_POS					6
#define LENGTH_LOW_POS					7
#define UNCOMPLETE_READ_POS				8
#define DATA_ADDR_HIGH_POS				9
#define DATA_ADDR_LOW_POS				10

#define CONTROL_GOOD					0
#define CONTROL_DATA_TOGGLE				0x01
#define CONTROL_DATA_PID				0x02
#define CONTROL_PID						0x04
#define CONTROL_TIMEOUT					0x08
#define CONTROL_CRC16					0x10
#define CONTROL_STALL					0x20
#define CONTROL_NO_DEVICE				0x40

//!< ްiKł̕ψʗp`̑g
#define OFFSET_FIELD_MAXPACKETSIZE		7
#define OFFSET_FIELD_MSB_VID			9
#define OFFSET_FIELD_LSB_VID			8
#define OFFSET_FIELD_MSB_PID			11
#define OFFSET_FIELD_LSB_PID			10

#define OFFSET_DESCRIPTOR_LENGHT		0
#define OFFSET_FIELD_DESCRIPTOR_TYPE	1
#define OFFSET_FIELD_TOTAL_LENGHT		2
#define OFFSET_FIELD_BMATTRIBUTES		7
#define OFFSET_FIELD_MAXPOWER			8

#define OFFSET_FIELD_OTG_FEATURES		2

//! ̪Lqqpψ
#define OFFSET_FIELD_NB_INTERFACE		4
#define OFFSET_FIELD_CLASS				5
#define OFFSET_FIELD_SUB_CLASS			6
#define OFFSET_FIELD_PROTOCOL			7

#define OFFSET_FIELD_INTERFACE_NB		2
#define OFFSET_FIELD_ALT				3
#define OFFSET_FIELS_NB_OF_EP			4

#define OFFSET_FIELD_EP_ADDR			2
#define OFFSET_FIELD_EP_TYPE			3
#define OFFSET_FIELD_EP_SIZE			4
#define OFFSET_FIELD_EP_INTERVAL		6

//! ދLqqp`
#define OFFSET_DEV_DESC_CLASS			4	// uLqq̸׽̈pψ(̾)
#define HUB_CLASS_CODE					9	//  ׽̒l

#define HOST_FALSE						0
#define HOST_TRUE						1

U8 host_send_control (U8*);

/**
 * host_clear_endpoint_feature
 *
 * @brief ̊֐ʹ߲ĉv𑗂܂B
 *
 * @param	U8 ep	(ڕW߲Ĕԍ)
 *
 * @return	
 */
#define host_clear_endpoint_feature(ep)	(usb_request.bmRequestType = 0x02,\
										 usb_request.bRequest      = CLEAR_FEATURE,\
										 usb_request.wValue        = FEATURE_ENDPOINT_HALT << 8,\
										 usb_request.wIndex        = ep,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))
/**
 * host_get_configuration
 *
 * @brief ̊֐͌`Ԑݒ擾v𑗂܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_get_configuration()		(usb_request.bmRequestType = 0x80,\
										 usb_request.bRequest      = GET_CONFIGURATION,\
										 usb_request.wValue        = 0,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 1,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))
/**
 * host_set_configuration
 *
 * @brief ̊֐͌`Ԑݒݒv𑗂܂B
 *
 * @param	U8	ɂ`Ԑݒԍ
 *
 * @return	
 */
#define host_set_configuration(cfg_nb)	(usb_request.bmRequestType = 0x00,\
										 usb_request.bRequest      = SET_CONFIGURATION,\
										 usb_request.wValue        = cfg_nb,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))
/**
 * host_set_interface
 *
 * @brief ̊֐Ͳ̪ɑ΂ē̑֐ݒw肷邽߂ɲ̪ݒv𑗂܂B
 *
 * @param	U8	interface_nb (̪)
 *			U8	alt_setting (ɂ֐ݒ)
 *
 * @return	
 */
#define host_set_interface(interface_nb,alt_setting)	(usb_request.bmRequestType = 0x00,\
										 usb_request.bRequest      = SET_INTERFACE,\
										 usb_request.wValue        = alt_setting,\
										 usb_request.wIndex        = interface_nb,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * host_get_device_descriptor_uncomplete
 *
 * @brief ̊֐͑uLqq擾v𑗂܂B
 * 󂯎Lqq\data_stagezɊi[܂B
 * 󂯎Lqq߲͐ߒɐ܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_get_device_descriptor_uncomplete()	(usb_request.bmRequestType = 0x80,\
										 usb_request.bRequest      = GET_DESCRIPTOR,\
										 usb_request.wValue        = DEVICE_DESCRIPTOR << 8,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 64,\
										 usb_request.uncomplete_read = TRUE,\
										 host_send_control(data_stage))

/**
 * host_get_device_descriptor
 *
 * @brief ̊֐͑uLqq擾v𑗂܂B
 * 󂯎Lqq\data_stagezɊi[܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_get_device_descriptor()	(usb_request.bmRequestType = 0x80,\
										 usb_request.bRequest      = GET_DESCRIPTOR,\
										 usb_request.wValue        = DEVICE_DESCRIPTOR << 8,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 18,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))
/**
 * host_get_configuration_descriptor
 *
 * @brief ̊֐͑u`Ԑݒ擾v𑗂܂B
 * 󂯎`ԐݒLqq\data_stagezɊi[܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_get_configuration_descriptor()	(usb_request.bmRequestType = 0x80,\
										 usb_request.bRequest      = GET_DESCRIPTOR,\
										 usb_request.wValue        = CONFIGURATION_DESCRIPTOR << 8,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 255,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

#define host_get_descriptor_uncomplete()	(usb_request.bmRequestType = 0x80,\
										 usb_request.bRequest      = GET_DESCRIPTOR,\
										 usb_request.wValue        = 0,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 64,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))
/**
 * host_set_address
 *
 * @brief ̊֐ͱڽݒv𑗂܂B
 *
 * @param	U8	ڽ(uɑꂽڽ)
 *
 * @return	
 */
#define host_set_address(addr)			(usb_request.bmRequestType = 0x00,\
										 usb_request.bRequest      = SET_ADDRESS,\
										 usb_request.wValue        = (U16)addr,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * host_set_feature_remote_wakeup
 *
 * @brief ̊֐͏uuNݒ𑗂܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_set_feature_remote_wakeup()	(usb_request.bmRequestType = 0x00,\
										 usb_request.bRequest      = SET_FEATURE,\
										 usb_request.wValue        = 1,\
										 usb_request.wIndex        = 1,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

#if (USB_OTG_FEATURE == ENABLED)
/**
 * host_set_feature_a_hnp_support
 *
 * @brief ̊֐A-uHNPx邱ƂB-uɒm点邽߂"a_hnp_support"@\ݒ𑗂܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_set_feature_a_hnp_support()	(usb_request.bmRequestType = 0x00,\
										 usb_request.bRequest      = SET_FEATURE,\
										 usb_request.wValue        = 4,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * host_set_feature_b_hnp_enable
 *
 * @brief ̊֐B-uHNPn߂邽߂"b_hnp_enable"@\ݒ𑗂܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_set_feature_b_hnp_enable()	(usb_request.bmRequestType = 0x00,\
										 usb_request.bRequest      = SET_FEATURE,\
										 usb_request.wValue        = 3,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))
#endif

/**
 * host_ms_get_max_lun
 *
 * @brief ̊֐͑eʋLwv"őLUN擾"𑗂܂B
 *
 * @param	Ȃ
 *
 * @return	
 */
#define host_ms_get_max_lun()			(usb_request.bmRequestType = 0xA1,\
										 usb_request.bRequest      = MS_GET_MAX_LUN,\
										 usb_request.wValue        = 0,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 1,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * Get_VID
 *
 * @brief ̊֐͐ڑꂽuVIDԂ܂B
 *
 * @param	Ȃ
 *
 * @return	U16	(VIDl)
 */
#define Get_VID()						(device_VID)

/**
 * Get_PID
 *
 * @brief ̊֐͐ڑꂽuPIDԂ܂B
 *
 * @param	Ȃ
 *
 * @return	U16	(PIDl)
 */
#define Get_PID()						(device_PID)

/**
 * Get_maxpower
 *
 * @brief ̊֐͐ڑu̍őd(2mAP)Ԃ܂B
 *
 * @param	Ȃ
 *
 * @return	U8	(őd͒l)
 */
#define Get_maxpower()					(maxpower)

/**
 * @brief ̊֐͎w肵̪ƒgUSB׽Ԃ܂B
 *
 * @param	U8s_interface:	x̪ԍ
 *
 * @return	U16	(׽)
 */
#define Get_class(s_interface)			(interface_supported[s_interface].class)

/**
 * @brief ̊֐͎w肵̪ƒgUSB׽Ԃ܂B
 *
 * @param	U8	s_interface:	x̪ԍ
 *
 * @return	U16	(׽)
 */
#define Get_subclass(s_interface)		(interface_supported[s_interface].subclass)

/**
 * @brief ̊֐͎w肵̪ƒgUSBKԂ܂B
 *
 * @param	U8	s_interface:	x̪ԍ
 *
 * @return	U16	(K񕄍)
 */
#define Get_protocol(s_interface)		(interface_supported[s_interface].protocol)

/**
 * @brief ̊֐͎w肵̪Ƃ̲̪ł̴߲Ĕԍƒg߲ ڽԂ܂B
 *
 * @param	U8 s_interface:	x̪ԍ
 * @param	U8 n_ep:		̲̪ł̴߲Ĕԍ
 *
 * @return	U8	(߲ ڽ)
 */
#define Get_ep_addr(s_interface,n_ep)	(interface_supported[s_interface].ep_addr[n_ep])

/**
 * @brief ̊֐͎x̪ƒg߲ĐԂ܂B
 *
 * @param	U8 s_interface:	x̪ԍ
 *
 * @return	U8 (߲Đ)
 */
#define Get_nb_ep(s_interface)			(interface_supported[s_interface].nb_ep)

/**
 * @brief ̊֐͎x̪ƒg֐ݒ̈搔Ԃ܂B
 *
 * @param	U8 s_interface:	x̪ԍ
 *
 * @return	U8 (֐ݒl)
 */
#define Get_alts_s(s_interface)			(interface_supported[s_interface].altset_nb)

/**
 * @brief ̊֐͎x̪ƒg̪ԍԂ܂B
 *
 * @param	U8 s_interface:	x̪ԍ
 *
 * @return	U8 (̪)
 */
#define Get_interface_number(s_interface)	(interface_supported[s_interface].interface_nb)

/**
 * @brief ̊֐͐ڑꂽuŎx̪Ԃ܂B
 *
 * @param	Ȃ
 *
 * @return	U8:	̪
 */
#define Get_nb_supported_interface()	(nb_interface_supported)

/**
 * @brief ̊֐͐ڑꂽuȋd̏ꍇTRUEԂ܂B
 *
 * @param	Ȃ
 *
 * @return	TRUE܂FALSE
 */
#define Is_device_self_powered()		((bmattributes & (1<<BIT_SELF_POWERED)) ? TRUE : FALSE)

/**
 * @brief ̊֐͑uuNxꍇTRUEԂ܂B
 *
 * @param	Ȃ
 *
 * @return	TRUE܂FALSE
 */
#define Is_device_supports_remote_wakeup()	((bmattributes & (1<<BIT_REMOTE_WAKEUP)) ? TRUE : FALSE)

/**
 * @brief ̊֐͑uSRPxꍇTRUEԂ܂B
 *
 * @param	Ȃ
 *
 * @return U8:	SRP
 */
#define Is_device_supports_srp()		((otg_features_supported & (1<<BIT_SRP_SUPPORT)) ? TRUE : FALSE)

/**
 * @brief ̊֐͑uHNPxꍇTRUEԂ܂B
 *
 * @param	Ȃ
 *
 * @return U8: HNP
 */
#define Is_device_supports_hnp()		((otg_features_supported & (1<<BIT_HNP_SUPPORT)) ? TRUE : FALSE)

extern U8 nb_interface_supported;
extern S_interface interface_supported[MAX_INTERFACE_SUPPORTED];
extern U16 device_PID;
extern U16 device_VID;
extern U8 bmattributes;
extern U8 maxpower;

U8 host_check_VID_PID (void);
#if (USB_OTG_FEATURE == ENABLED)
  U8 host_check_OTG_features (void);
#endif
U8 host_check_class (void);
U8 host_auto_configure_endpoint();
T_DESC_OFFSET get_interface_descriptor_offset (U8 interface, U8 alt);
U8 host_get_hwd_pipe_nb (U8 ep_addr);

//! @}

#endif // _USB_HOST_ENUM_H_
